/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.chat.service.persistence;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.util.ReferenceRegistry;

/**
 * @author Brian Wing Shun Chan
 */
public class StatusFinderUtil {
	public static java.util.List<java.lang.Object[]> findByModifiedDate(
		long companyId, long userId, long modifiedDate, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getFinder()
				   .findByModifiedDate(companyId, userId, modifiedDate, start,
			end);
	}

	public static java.util.List<java.lang.Object[]> findBySocialRelationType(
		long userId, int type, long modifiedDate, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getFinder()
				   .findBySocialRelationType(userId, type, modifiedDate, start,
			end);
	}

	public static java.util.List<java.lang.Object[]> findByUsersGroups(
		long userId, long modifiedDate, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getFinder().findByUsersGroups(userId, modifiedDate, start, end);
	}

	public static StatusFinder getFinder() {
		if (_finder == null) {
			_finder = (StatusFinder)PortletBeanLocatorUtil.locate(com.liferay.chat.service.ClpSerializer.getServletContextName(),
					StatusFinder.class.getName());

			ReferenceRegistry.registerReference(StatusFinderUtil.class,
				"_finder");
		}

		return _finder;
	}

	public void setFinder(StatusFinder finder) {
		_finder = finder;

		ReferenceRegistry.registerReference(StatusFinderUtil.class, "_finder");
	}

	private static StatusFinder _finder;
}